# Track-Actions
Adds new actions to **Presonus Studio One** version 3 and greater as described below.  <br>

**Installation:** Download the [version 1.1.1 package file from here](https://github.com/ExpressMix/Track-Actions/raw/master/trackactions.package) and put it in the **Studio One 3\Scripts** folder and restart Studio One. You can also paste the [command bar group xml](https://github.com/ExpressMix/Track-Actions/blob/master/command%20bar%20group.xml) into your **commandbar.xml** file and use the toolbar group and icons shown below. If you do that, install the package before editing the commandbar file or do both at the same time so the actions will bind to the icons<br>

![alt text](https://image.prntscr.com/image/YdTIx4CRRd_cPhvM9OyjDg.png)

***1.1.1 fixes a number of nagging bugs.***

---

***List Of Actions Included in the Track Actions package***<br>

***Version 1.0.0*** <br>

+ **Fade at Split** <br>
  Fading out and in at a clip split point based on custom fade settings. This works from right to left because the selected clip after a split defaults to the clip to the right of the split. If using it manually on an existing split, select the clip on the right.

+  **Fade In/Out** <br>
  Two actions to fade clips only in or out. This is more flexible than Create Autofades as it uses the custom fade settings and only fades in or out, not both at the same time, which in some cases can inadvertently affect a transient at the clip start if the clip start is trimmed close to a drum transient or similar.

+  **Fade Settings** <br>
  Dialog: Set the length and type of fade to use for the fade actions.<br>
  
  ![alt text](https://image.prntscr.com/image/UMvT3v2BTmyOY9TVQRc-kw.png)

+  **Remove Inactive Layers** <br>
  This removes all inactive layers for a selected single track. It makes a version backup before removing layers, *[Track Name] Before 
  Removing Layers*.  Note: I can't yet get this working for all selected tracks but if I ever can I will update it.

+  **Remove Empty/Disabled Tracks** <br>
  These two actions remove all visible tracks that have no media clips on their active layers or are disabled in the second case. It makes a version backup before removing tracks, *Before Removing Empty [or Disabled]*

+  **Filter Tracks** <br>
  Dialog: Only show the arrange tracks which contain the case insensitive search text, hide all others. *This action requires that **Track > Select Scene 1** be set to make all tracks visible for it to work correctly. It's a work in progress and has to exclude folder tracks by necessity.* <br>
  
 ![alt text](https://image.prntscr.com/image/A56ScBOiTkyZDBoh66LK_A.png)

+  **Replace Track Names** <br>
    Dialog: Batch replace track names, case sensitive matching.<br>
    
  ![alt text](https://image.prntscr.com/image/bybtrYD-QKaNlo4hG5c9GQ.png)

+  **Toggle Dim Master Bus** <br>
  Toggle between Unity and Dim Level. Default -10 dim level. Customize dim level by appending the master bus name. <br>
  *["Master - 20"]*

+  **Format Track Names** <br>
  Batch format track names, *i.e., bAsS > Bass*.

+  **Reset Console** <br>
  Faders to 0, pans center, plugins off. Makes a version backup before reset *[Before Console Reset]*
  
  ---

***Version 1.0.1*** <br>

+   Added **Actions: Track > Nudge Play Cursor** & **Track > Nudge Play Cursor Back**.  <br>
  These move the play cursor forward or backward by the grid value if snap is on otherwise in 1 ms steps.  *They exist in the Track command category to allow them to be non-contextual to media selection and also because the Transport menu is not available to scripted actions.*

---

***Version 1.0.2***

+ **Fixed:** Non-fatal error with Remove Inactive Layers if no arrange track is selected.<br>
+ **Change:** Adjusted Track Filter form and controls.

---

***Version 1.0.3***

+ **Added:** Musical Functions > Midi Logical Editor.<br>

![alt text](https://image.prntscr.com/image/XsjsT6XrQXSbptMrS7w51w.png)

---

 ***Version 1.0.4***

+ **Added:** Track > Bounce To Target Track.<br>
   Select a clip and add a second track to the selection and it puts the bounce on that track.

---

 ***Version 1.0.5***

+ **Added:** Track > Toggle Solo In Front.<br>
   Create a sub out named "Dim Solo" and save it the default I/O setup and pull the fader down to -20 or whatever.   Select a channel or channels and fire the action and it toggles all non-selected channel assignments to the Dim Solo bus, giving a faux Solo In Front and toggles back to normal.

---

***Version 1.0.6***

+ **Added:** New buttons on Logical Editor to more easily target GM kick, snare, hats.<br>

---

***Version 1.0.7***

+ **Added:** Track > Rename Events from Track.<br>
Renames all events on all selected tracks to the track names.<br>
Track > Strip Numbers:  Strip numeric characters from all track names.

---

***Version 1.0.8***

+ **Added:**  Track > Add Gain / Trim Gain / Gain Settings Dialog<br>
Allows quickly trimming or gaining an audio clip or range with a dialog to set the default level from 1 to 6db.  Either select an audio clip or draw a range and it will split and crossfade and trim or gain by the default amount.<br>

![alt text](https://image.prntscr.com/image/g2k79WFCSBiOzHuxeg6uJA.png)

---

***Version 1.1.0 revsion b***

+ **Added:**  Actions **Conform Colors** and **Conform Colors: Setup*** - Choose colors for certain types of tracks by name or type from the Studio One color palette and the Conform Colors action will always color all of the tracks to those colors by track name.<br>

  Color dialog updates arrange tracks in real time so that you can see what the default color set for the **Conform Colors** action looks like as you edit the group colors in the dialog. Also added the ability to quickly color shade the main groups with menus. <br>

![alt text](https://image.prntscr.com/image/42w2_2z6TAWx01H6fv30vg.png)

+  Sample of a few of the color groups... <br>

  ![alt text](https://image.prntscr.com/image/uEMC4VJRQD2ZRPPeAr8UUg.png)


  ---

***Version 1.1.1***<br>
Sqaushed some bugs.  If you had errors in earlier versions please update

**Fixed:**  Script error warning alerts when opening or closing songs.<br>
**Fixed:**  Gain setting dialog opens with incorrect gain setting value.<br>
**Change:**   Moved color dialog code to trackColors.js<br>
**Change:**   Moved all helper functions to functions.js<br>

  ---

***Version 1.1.2***<br>
Add New Action:  Event | Rename Tracks From Events