
include_file("functions.js");
const kPackageID = "trackActions";
const scriptTitle = "Track Actions";

function trackColorDialog(actionTarget)
{
    this.interfaces = [Host.Interfaces.IEditTask, Host.Interfaces.IParamObserver]
   
    this.prepareEdit = function (context)
    {
        this.defaultColors =
        [
            "orange",  "774d00", "8e5c00","a66b00", "be7b00", "d68a00", 
            "blue", "1e2c47", "324a76", "4668a5", "5a86d5", "83aaf0", 
            "yellow", "7f7645", "998d53", "b2a561", "ccbc6f", "e5d47d", 
            "tan", "373025", "453c2f", "534838", "615441", "6f604b", 
            "red", "65100b", "742723", "833f3b", "935754", "a26f6c",
            "violet", "551a8b", "663096", "7647a2", "885ead", "9975b9",
            "green", "1b372e", "295345", "376f5c", "458b74", "7cad9d"
        ]

        this.paramList = Host.Classes.createInstance("CCL:ParamList")
        this.paramList.controller = this;

        this.instruments = "drum bass guitar keyboard synth string violin viola cello contra " +
        "brass trumpet trombone frHorn tuba wind sax clarinet oboe bassoon vocal lead double " +
        "harm speech master groupBus fxBus perc sfx stringList brassList reedList vocalList";

        this.stringList = this.paramList.addMenu("stringList");
        this.stringList.appendString("-");
        this.stringList.appendString("Red");
        this.stringList.appendString("Green");
        this.stringList.appendString("Blue");
        this.stringList.appendString("Orange");
        this.stringList.appendString("Yellow");
        this.stringList.appendString("Violet");
        this.stringList.appendString("Tan");
    
        this.brassList = this.paramList.addMenu("brassList");
        this.brassList.appendString("-");
        this.brassList.appendString("Red");
        this.brassList.appendString("Green");
        this.brassList.appendString("Blue");
        this.brassList.appendString("Orange");
        this.brassList.appendString("Yellow");
        this.brassList.appendString("Violet");
        this.brassList.appendString("Tan");        

        this.reedList = this.paramList.addMenu("reedList");
        this.reedList.appendString("-");
        this.reedList.appendString("Red");
        this.reedList.appendString("Green");
        this.reedList.appendString("Blue");
        this.reedList.appendString("Orange");
        this.reedList.appendString("Yellow");
        this.reedList.appendString("Violet");
        this.reedList.appendString("Tan");

        this.vocalList = this.paramList.addMenu("vocalList");
        this.vocalList.appendString("-");
        this.vocalList.appendString("Red");
        this.vocalList.appendString("Green");
        this.vocalList.appendString("Blue");
        this.vocalList.appendString("Orange");
        this.vocalList.appendString("Yellow");
        this.vocalList.appendString("Violet");
        this.vocalList.appendString("Tan");
        
                                    
            this.saveColorsButton = this.paramList.addInteger(0,1,"saveColorsButton")

            this.drum = this.paramList.addColor("drum");
            this.bass = this.paramList.addColor("bass")
            this.guitar = this.paramList.addColor("guitar")
            this.keyboard = this.paramList.addColor("keyboard")
            this.synth = this.paramList.addColor("synth")
            this.perc = this.paramList.addColor("perc")
            this.string = this.paramList.addColor("string");


            this.drum.palette = Host.Engine.TrackColorPalette;
            this.drum.value = Host.Engine.TrackColorPalette.getAt(0);

            this.bass.palette = Host.Engine.TrackColorPalette;
            this.bass.value = Host.Engine.TrackColorPalette.getAt(0);
      
            this.guitar.palette = Host.Engine.TrackColorPalette;
            this.guitar.value = Host.Engine.TrackColorPalette.getAt(0);
            
            this.keyboard.palette = Host.Engine.TrackColorPalette;
            this.keyboard.value = Host.Engine.TrackColorPalette.getAt(0);

           
            this.synth.palette = Host.Engine.TrackColorPalette;
            this.synth.value = Host.Engine.TrackColorPalette.getAt(0);

            
            this.perc.palette = Host.Engine.TrackColorPalette;
            this.perc.value = Host.Engine.TrackColorPalette.getAt(0);

            
            this.string.palette = Host.Engine.TrackColorPalette;
            this.string.value = Host.Engine.TrackColorPalette.getAt(0);
            this.violin = this.paramList.addColor("violin")
            this.violin.palette = Host.Engine.TrackColorPalette;
            this.violin.value = Host.Engine.TrackColorPalette.getAt(0)
            this.viola = this.paramList.addColor("viola")
            this.viola.palette = Host.Engine.TrackColorPalette;
            this.viola.value = Host.Engine.TrackColorPalette.getAt(0)
            this.cello = this.paramList.addColor("cello")
            this.cello.palette = Host.Engine.TrackColorPalette;
            this.cello.value = Host.Engine.TrackColorPalette.getAt(0)
            this.contra = this.paramList.addColor("contra")
            this.contra.palette = Host.Engine.TrackColorPalette;
            this.contra.value = Host.Engine.TrackColorPalette.getAt(0)

            this.brass = this.paramList.addColor("brass")
            this.brass.palette = Host.Engine.TrackColorPalette;
            this.brass.value = Host.Engine.TrackColorPalette.getAt(0);
            this.trumpet = this.paramList.addColor("trumpet")
            this.trumpet.palette = Host.Engine.TrackColorPalette;
            this.trumpet.value = Host.Engine.TrackColorPalette.getAt(0);
            this.trombone = this.paramList.addColor("trombone")
            this.trombone.palette = Host.Engine.TrackColorPalette;
            this.trombone.value = Host.Engine.TrackColorPalette.getAt(0);
            this.frHorn = this.paramList.addColor("frHorn")
            this.frHorn.palette = Host.Engine.TrackColorPalette;
            this.frHorn.value = Host.Engine.TrackColorPalette.getAt(0);
            this.tuba = this.paramList.addColor("tuba")
            this.tuba.palette = Host.Engine.TrackColorPalette;
            this.tuba.value = Host.Engine.TrackColorPalette.getAt(0);

            this.wind = this.paramList.addColor("wind")
            this.wind.palette = Host.Engine.TrackColorPalette;
            this.wind.value = Host.Engine.TrackColorPalette.getAt(0);
            this.sax = this.paramList.addColor("sax")
            this.sax.palette = Host.Engine.TrackColorPalette;
            this.sax.value = Host.Engine.TrackColorPalette.getAt(0);
            this.clarinet = this.paramList.addColor("clarinet")
            this.clarinet.palette = Host.Engine.TrackColorPalette;
            this.clarinet.value = Host.Engine.TrackColorPalette.getAt(0);
            this.oboe = this.paramList.addColor("oboe")
            this.oboe.palette = Host.Engine.TrackColorPalette;
            this.oboe.value = Host.Engine.TrackColorPalette.getAt(0);
            this.bassoon = this.paramList.addColor("bassoon")
            this.bassoon.palette = Host.Engine.TrackColorPalette;
            this.bassoon.value = Host.Engine.TrackColorPalette.getAt(0);

            this.vocal = this.paramList.addColor("vocal")
            this.vocal.palette = Host.Engine.TrackColorPalette;
            this.vocal.value = Host.Engine.TrackColorPalette.getAt(0);
            this.lead = this.paramList.addColor("lead")
            this.lead.palette = Host.Engine.TrackColorPalette;
            this.lead.value = Host.Engine.TrackColorPalette.getAt(0);
            this.double = this.paramList.addColor("double")
            this.double.palette = Host.Engine.TrackColorPalette;
            this.double.value = Host.Engine.TrackColorPalette.getAt(0);
            this.harm = this.paramList.addColor("harm")
            this.harm.palette = Host.Engine.TrackColorPalette;
            this.harm.value = Host.Engine.TrackColorPalette.getAt(0);
            this.speech = this.paramList.addColor("speech")
            this.speech.palette = Host.Engine.TrackColorPalette;
            this.speech.value = Host.Engine.TrackColorPalette.getAt(0);

            this.master = this.paramList.addColor("master")
            this.master.palette = Host.Engine.TrackColorPalette;
            this.master.value = Host.Engine.TrackColorPalette.getAt(0);

            this.groupBus = this.paramList.addColor("groupBus")
            this.groupBus.palette = Host.Engine.TrackColorPalette;
            this.groupBus.value = Host.Engine.TrackColorPalette.getAt(0);

            this.fxBus = this.paramList.addColor("fxBus")
            this.fxBus.palette = Host.Engine.TrackColorPalette;
            this.fxBus.value = Host.Engine.TrackColorPalette.getAt(0);

            this.sfx = this.paramList.addColor("sfx")
            this.sfx.palette = Host.Engine.TrackColorPalette;
            this.sfx.value = Host.Engine.TrackColorPalette.getAt(0);
            

            var trackColors = readTextFile(scriptTitle, "trackColorSet");
            
            if (trackColors != undefined)
            {
                this.drum.value =       Number(trackColors[0]);
                this.bass.value =       Number(trackColors[1]);
                this.guitar.value =     Number(trackColors[2]);
                this.keyboard.value =   Number(trackColors[3]);
                this.synth.value =      Number(trackColors[4]);

                this.string.value =     Number(trackColors[5]);
                this.violin.value =     Number(trackColors[6]);
                this.viola.value =      Number(trackColors[7]);
                this.cello.value =      Number(trackColors[8]);
                this.contra.value =     Number(trackColors[9]);

                this.brass.value =      Number(trackColors[10]);
                this.trumpet.value =    Number(trackColors[11]);
                this.trombone.value =   Number(trackColors[12]);
                this.frHorn.value =     Number(trackColors[13]);
                this.tuba.value =       Number(trackColors[14]);

                this.wind.value =       Number(trackColors[15]);
                this.sax.value =        Number(trackColors[16]);
                this.clarinet.value =   Number(trackColors[17]);
                this.oboe.value =       Number(trackColors[18]);
                this.bassoon.value =    Number(trackColors[19]);

                this.vocal.value =      Number(trackColors[20]);
                this.lead.value =       Number(trackColors[21]);
                this.double.value =     Number(trackColors[22]);
                this.harm.value =       Number(trackColors[23]);
                this.speech.value =     Number(trackColors[24]);

                this.master.value =     Number(trackColors[25]); 
                this.groupBus.value =   Number(trackColors[26]);
                this.fxBus.value =      Number(trackColors[27]);

                this.perc.value =       Number(trackColors[28]);
                this.sfx.value =        Number(trackColors[29]);
            }                              
                   
        return Host.Results.kResultOk;
    }

    // ---------------------------------------------------------------------

    this.performEdit = function (context)
    {
        this.context = context;

        if (actionTarget == "color")
        {
            this.colorTracks();
            return;
        }

       return Host.GUI.runDialog(Host.GUI.Themes.getTheme(kPackageID), "Track Colors", this) ;
    }


    this.paramChanged = function (param)
    {
        if (this.instruments.indexOf(param.name) > -1)
        {
            this.colorTracks(); 
        }

        if (param.name == "stringList")
        {
            for(i=0; i < this.defaultColors.length; i++)
            {               
                if (this.defaultColors[i].trim() == param.string.toLowerCase().trim())
                {    
                    this.string.value = getColorVal(this.defaultColors[i + 1]);
                    this.violin.value = getColorVal(this.defaultColors[i + 2]);
                    this.viola.value = getColorVal(this.defaultColors[i + 3]);
                    this.cello.value = getColorVal(this.defaultColors[i + 4]);
                    this.contra.value = getColorVal(this.defaultColors[i + 5]); 
                    this.colorTracks();  
                    return;
                }      
            }
        }

        if (param.name == "brassList")
        {
            for(i=0; i < this.defaultColors.length; i++)
            {
                if (this.defaultColors[i].trim() == param.string.toLowerCase().trim())
                {    
                    this.brass.value = getColorVal(this.defaultColors[i + 1]);
                    this.trumpet.value = getColorVal(this.defaultColors[i + 2]);
                    this.trombone.value = getColorVal(this.defaultColors[i + 3]);
                    this.frHorn.value = getColorVal(this.defaultColors[i + 4]);
                    this.tuba.value = getColorVal(this.defaultColors[i + 5]); 
                    this.colorTracks();   
                    return;
                }      
            }
        }

        if (param.name == "reedList")
        {
            for(i=0; i < this.defaultColors.length; i++)
            {
                if (this.defaultColors[i].trim() == param.string.toLowerCase().trim())
                {    
                    this.wind.value = getColorVal(this.defaultColors[i + 1]);
                    this.sax.value = getColorVal(this.defaultColors[i + 2]);
                    this.clarinet.value = getColorVal(this.defaultColors[i + 3]);
                    this.oboe.value = getColorVal(this.defaultColors[i + 4]);
                    this.bassoon.value = getColorVal(this.defaultColors[i + 5]); 
                    this.colorTracks();      
                    return;
                }      
            }
        }

        if (param.name == "vocalList")
        {
            for(i=0; i < this.defaultColors.length; i++)
            {
                if (this.defaultColors[i].trim() == param.string.toLowerCase().trim())
                {    
                    this.vocal.value = getColorVal(this.defaultColors[i + 1]);
                    this.lead.value = getColorVal(this.defaultColors[i + 2]);
                    this.double.value = getColorVal(this.defaultColors[i + 3]);
                    this.harm.value = getColorVal(this.defaultColors[i + 4]);
                    this.speech.value = getColorVal(this.defaultColors[i + 5]); 
                    this.colorTracks();  
                    return;  
                }      
            }
        }

        // -------------------------------------------------------------------------------------------

        if (param.name == "saveColorsButton") 
        {
            var colorText = this.drum.value + "\r\n"  + 
                            this.bass.value + "\r\n"  + 
                            this.guitar.value + "\r\n"  +
                            this.keyboard.value + "\r\n"  + 
                            this.synth.value + "\r\n"  + 

                            this.string.value + "\r\n"  +
                            this.violin.value + "\r\n"  + 
                            this.viola.value + "\r\n"  + 
                            this.cello.value + "\r\n"  + 
                            this.contra.value + "\r\n"  +

                            this.brass.value + "\r\n"  + 
                            this.trumpet.value + "\r\n"  +     
                            this.trombone.value + "\r\n"  +    
                            this.frHorn.value + "\r\n"  +      
                            this.tuba.value + "\r\n"  +        

                            this.wind.value + "\r\n"  +        
                            this.sax.value + "\r\n"  +         
                            this.clarinet.value + "\r\n"  +    
                            this.oboe.value + "\r\n"  +        
                            this.bassoon.value + "\r\n"  +     

                            this.vocal.value + "\r\n"  +       
                            this.lead.value + "\r\n"  +        
                            this.double.value + "\r\n"  +      
                            this.harm.value + "\r\n"  +        
                            this.speech.value + "\r\n"  +      

                            this.master.value + "\r\n"  +       
                            this.groupBus.value + "\r\n"  +    
                            this.fxBus.value + "\r\n" +
                            this.perc.value + "\r\n" +
                            this.sfx.value ;

            writeTextFile(scriptTitle, "trackColorSet", colorText);
            
        }
        
    } // end this param chnanged

    // ---------------------------------------------------------------------

    this.colorTracks = function ()
    {
        var context = this.context;
        var functions = this.context.functions;
        functions.executeImmediately = true;
        
        // bus  -------------------------------------------------------------
        var channels = getChannels(context,1,false)
        for (i=0; i < channels.length; i++)
        {
            var channel = channels[i];

                if ( channels[i].toString().indexOf("AudioGroup") > -1 )
                {
                    channel.findParameter("color").value = this.groupBus.value;
                }
    
                if ( channels[i].toString().indexOf("AudioEffect") > -1 )
                {
                    channel.findParameter("color").value = this.fxBus.value;
                }
        }
    
        var masterBus = context.functions.root.environment.find("MixerConsole").getChannelList(3).getChannel(0);
        masterBus.findParameter("color").value = this.master.value;
    
    
        var tracks = getTracks(context);

    
        for ( i = 0; i < tracks.length; i++)
        {
            var track = tracks[i];
                var drums = ["kick", "snare", "drum", "hat", "hh", "tom", "crash",
                            "cymbal", "ride", "rim", "stick", "splash", "china", 
                            "room", "overhead", "kit" ]
        
                for ( d = 0; d < drums.length; d++)
                {
                    if ( track.name.toString().toLowerCase().indexOf(drums[d]) > -1 )
                    {            
                        functions.colorizeEvent(track, this.drum.value);
                        continue;
                        break;
                    }
                }
            
    
            // bass
                if (    track.name.toString().toLowerCase().indexOf("bass") > -1 &&
                        track.name.toString().toLowerCase().indexOf("bassoon") < 0 &&
                        track.name.toString().toLowerCase().indexOf("drum") < 0 &&
                        track.name.toString().toLowerCase().indexOf("clar") < 0  &&
                        track.name.toString().toLowerCase().indexOf("trom") < 0)
                {
                    functions.colorizeEvent(track, this.bass.value);
                    continue;
                }
    
            // guitars
            
                if (    track.name.toString().toLowerCase().indexOf("gtr") > -1 ||
                        track.name.toString().toLowerCase().indexOf("guitar") > -1 ||
                        track.name.toString().toLowerCase().indexOf("guit") > -1  ||
                        track.name.toString().toLowerCase().indexOf("banj") > -1     )
                {
                    functions.colorizeEvent(track, this.guitar.value);
                    continue;
                }
            
    
            // keyboard
            
                if (    track.name.toString().toLowerCase().indexOf("piano") > -1 ||
                        track.name.toString().toLowerCase().indexOf("organ") > -1 ||
                        track.name.toString().toLowerCase().indexOf("clav") > -1  ||
                        track.name.toString().toLowerCase().indexOf("key") > - 1 ||
                        track.name.toString().toLowerCase().indexOf("glock") > -1  ||
                        track.name.toString().toLowerCase().indexOf("grand") > -1  ||
                        track.name.toString().toLowerCase().indexOf("tonk") > -1  )
                {
                    functions.colorizeEvent(track, this.keyboard.value);
                    continue;
                }
                
            // synth
           
                if (    track.name.toString().toLowerCase().indexOf("synth") > -1 ||
                        track.name.toString().toLowerCase().indexOf("arp") > -1 ||
                        track.name.toString().toLowerCase().indexOf("sync") > -1 ||
                        track.name.toString().toLowerCase().indexOf("saw") > -1 ||
                        track.name.toString().toLowerCase().indexOf("pad") > -1  )
                {
                    functions.colorizeEvent(track, this.synth.value);
                        continue;
                }
            
            // Strings                    
                if ( track.name.toString().toLowerCase().indexOf("string") > -1 )
                        { functions.colorizeEvent(track, this.string.value) ;  }
                if ( track.name.toString().toLowerCase().indexOf("violin") > -1 )
                        { functions.colorizeEvent(track, this.violin.value) ;  }
                if ( track.name.toString().toLowerCase().indexOf("viola") > -1 )
                        { functions.colorizeEvent(track, this.viola.value) ;  }
                if ( track.name.toString().toLowerCase().indexOf("cello") > -1 )
                        {   functions.colorizeEvent(track, this.cello.value) ; }
                if ( track.name.toString().toLowerCase().indexOf("contra") > -1 )
                        { functions.colorizeEvent(track, this.contra.value) ;  }
            
    
            // Brass                     
                if ( track.name.toString().toLowerCase().indexOf("brass") > -1 )
                        { functions.colorizeEvent(track, this.brass.value) ;  }
                if ( track.name.toString().toLowerCase().indexOf("trumpet") > -1 )
                        { functions.colorizeEvent(track, this.trumpet.value) ;  }
                if ( track.name.toString().toLowerCase().indexOf("trombone") > -1 )
                        { functions.colorizeEvent(track, this.trombone.value) ;  }
                if ( track.name.toString().toLowerCase().indexOf("french") > -1 ||
                        track.name.toString().toLowerCase().indexOf("horn") > -1 )
                        { functions.colorizeEvent(track, this.frHorn.value);   }
                if ( track.name.toString().toLowerCase().indexOf("tuba") > -1 )
                        { functions.colorizeEvent(track, this.tuba.value) ;  }
                
            // Wind                      
                if ( track.name.toString().toLowerCase().indexOf("flute") > -1 ||
                    track.name.toString().toLowerCase().indexOf("piccolo") > -1)
                        { functions.colorizeEvent(track, this.wind.value) ;  }
                if ( track.name.toString().toLowerCase().indexOf("sax") > -1 )
                        { functions.colorizeEvent(track, this.sax.value) ;  }
                if ( track.name.toString().toLowerCase().indexOf("clarinet") > -1 )
                        { functions.colorizeEvent(track, this.clarinet.value) ;  }
                if ( track.name.toString().toLowerCase().indexOf("oboe") > -1 )
                        { functions.colorizeEvent(track, this.oboe.value);   }
                if ( track.name.toString().toLowerCase().indexOf("bassoon") > -1 )
                        { functions.colorizeEvent(track, this.bassoon.value) ;  }
            
    
            //Vocal                     
                if ( track.name.toString().toLowerCase().indexOf("vocal") > -1 ||
                        track.name.toString().toLowerCase().indexOf("vox") > -1 ||
                        track.name.toString().toLowerCase().indexOf("voc") > -1 ||
                        track.name.toString().toLowerCase().indexOf("melody") > -1 ||
                        track.name.toString().toLowerCase().indexOf("aah") > -1 )
                        { functions.colorizeEvent(track, this.vocal.value) ;  }
        
                if ( track.name.toString().toLowerCase().indexOf("lead voc") > -1 )
                        { functions.colorizeEvent(track, this.lead.value) ;  }
        
                if ( ( track.name.toString().toLowerCase().indexOf("double") > -1 ||
                        track.name.toString().toLowerCase().indexOf("dbl") > -1) &&
                        track.name.toString().toLowerCase().indexOf("bass") < 0 )
                        { functions.colorizeEvent(track, this.double.value) ;  }
        
                if ( track.name.toString().toLowerCase().indexOf("harm") > -1 ||
                        track.name.toString().toLowerCase().indexOf("choir") > -1 )
                        { functions.colorizeEvent(track, this.harm.value);   }
        
                if ( track.name.toString().toLowerCase().indexOf("speech") > -1 ||
                        track.name.toString().toLowerCase().indexOf("voice") > -1  ||
                        track.name.toString().toLowerCase().indexOf("rap") > -1)
                        { functions.colorizeEvent(track, this.speech.value) ;  }  
                    
            // percussion
                var perc = ["conga", "bongo", "timbales", "cowbell", "triangle",,
                            "block", "timpani", "orch", "perc", "tamb", "harp",
                            "chime", "timbale", "agogo", "cabasa","whistle", "maraca",
                            "quijada"]
        
                for ( p = 0; p < perc.length; p++)
                {
                    if ( track.name.toString().toLowerCase().indexOf(perc[p]) > -1 )
                    {
                        functions.colorizeEvent(track, this.perc.value);
                        break;
                    }
                }   
            
            // sound fx
                if ( track.name.toString().toLowerCase().indexOf("fx") > -1 )
                                { functions.colorizeEvent(track, sfxColor) ;  }
            
        }
    }

}

function createInstance () 
{
    return new trackColorDialog ("edit");
}

function conformTrackColors () 
{
    return new trackColorDialog ("color");
}

